' ----------------------------------------------------------------
' ZX64 SIMULATOR V.0.3 by Carlo Santagostino (c) 2019
' ----------------------------------------------------------------

	DIM num AS UBYTE
	DIM rig AS INTEGER
	DIM tas AS STRING
	
	' Set character set
	POKE UINTEGER 23606, @typeface-256
	
    ' Initialize screen
100 INK 5: PAPER 1: BORDER 5: BRIGHT 0: FLASH 0: CLS
    PRINT AT 1,4;"**** ZX 64 BASIC V2 ****"
    PRINT AT 3,1;"48K RAM SYSTEM  ALL BYTES FREE"
	PRINT AT 5,0;"READY."
	PRINT FLASH 1;AT 6,0;" "
     
    ' Wait until key is PRESSED
    PAUSE 0 

	' Print all charset
200	CLS
	PRINT INK 7;AT 1,9;"ZX64 SIMULATOR"
	PRINT INK 7;AT 2,5;"by Carlo Santagostino"
	PRINT INK 7;AT 3,11;"(c) 2019"
	PRINT 
	PRINT INK 7;"CHR$ from 32 to 128 (ASCII):"
	FOR a=32 TO 128
		PRINT CHR$ a;
	NEXT a

	' Set UDG set #1
	POKE UINTEGER 23675, @typeface+768
	PRINT : PRINT
	PRINT INK 7;"CHR$ from 144 to 164 (UDG SET1):";
	FOR a=144 TO 164
		PRINT CHR$ a;
	NEXT a

	' Set UDG set #2
	POKE UINTEGER 23675, @typeface+1024
	PRINT : PRINT
	PRINT INK 7;"CHR$ from 144 to 164 (UDG SET2):";
	FOR a=144 TO 164
		PRINT CHR$ a;
	NEXT a

	' Set UDG set #3
	POKE UINTEGER 23675, @typeface+1280
	PRINT : PRINT
	PRINT INK 7;"CHR$ from 144 to 164 (UDG SET3):";
	FOR a=144 TO 164
		PRINT CHR$ a;
	NEXT a
	
	PRINT : PRINT
	PRINT FLASH 1;" "
	' Wait until key is PRESSED
    PAUSE 0 
	
	' The Labirinth
300	CLS
	RANDOMIZE
	rig = 0
	DO WHILE rig < 768
		num = RND * 2
		IF num=0 THEN PRINT "\";
		IF num=1 THEN PRINT "}";
		rig = rig + 1
	LOOP
	' Wait until key is PRESSED
	PAUSE 0
	
400	CLS
	PRINT AT 1,1;"PRESS 1 TO RESTART"
    PRINT AT 3,1;"PRESS 2 TO USE BASIC"
	PRINT AT 5,0;FLASH 1;" "
	' Wait until key is PRESSED
	PAUSE 0
	tas=INKEY$
	IF tas="1" THEN GOTO 100
	IF tas="2" THEN GOTO 500	
	GOTO 400

500
	END
	
typeface:
	asm
		incbin "ZX64_PETSCII.chr"
	end asm
	
